
var Engine = Matter.Engine,
    World = Matter.World,
    Bodies = Matter.Bodies,
    MouseConstraint = Matter.MouseConstraint,
    Render = Matter.Render,
    Mouse = Matter.Mouse,
    Runner = Matter.Runner,
    Composites = Matter.Composites,
    Common = Matter.Common;



/*

    var largeur_obstacles = 50;

    var obstacles_properties = {
      isStatic: true,
      render: {
        fillStyle: 'green',
        strokeStyle: 'red',
        lineWidth: 30
      }
    };

    var obstacles = [
      Matter.Bodies.rectangle(30, 120, 50, 200, obstacles_properties),

    ];

*/
var bars = [];
var particles = [];
var bounds = [];

var engine,world;

function setup() {

  var affiche_width = $('#affiche').innerWidth();
  var affiche_height = $('#affiche').innerHeight();

  createCanvas(affiche_width,affiche_height).parent('animation');
  rectMode(CENTER);


  // create engine
  engine = Engine.create();
  world = engine.world;

  var cols = 0, rows = 0;
  var spacing = width/cols;
  for (var i = 0; i < cols+1; i++) {
    for (var j = 0; j < rows; j++) {
      var x_pos = i*spacing + (j%2?spacing/2:0);
      var y_pos = j*spacing/Math.sqrt(2) + spacing;

      bars.push(new Particle(x_pos, y_pos, 1, {isStatic:true}, 50));
    }
  }

  // bottom
  bounds.push(new Boundary(width/2,height+50,width,100));

  // left
  bounds.push(new Boundary(-50,height/2,100,height));

  // right
  bounds.push(new Boundary(width+50,height/2,100,height));

  //baskets
  var baskets = cols;

  for (var x = 0; x < baskets; x++)  {
    if (x > 0) {
      bounds.push(new Boundary((width/baskets*x), height-150, 2, 300));
    }

  }


}

function addParticle() {
  particles.push(new Particle(mouseX,mouseY, 15)); /* COORDONNEES DU INFLOW PARTICLES*/ /*dernier chiffre:taille*/
}

var prevTime;
var maxAmount = 370;

function draw() {
  background(0x100);

  // var time = performance.now();
  // var ms = time - prevTime;
  // prevTime = time;

  Engine.update(engine);

  if (frameCount % 3 == 0 && particles.length < maxAmount) {
    addParticle();
  }


  for (var x = 0; x < bounds.length; x++) {
    var b = bounds[x];
    b.draw();
  }
  for (var x = 0; x < bars.length; x++) {
    var b = bars[x];
    b.draw();
  }
  for (var x = 0; x < particles.length; x++) {
    var p = particles[x];
    p.draw();
  }

}


// PARTICLE
function Particle(x,y,r,options,c) {
  this.r = r || 10;
  this.c = c ||color((190), (0x100),random(255));

  /*TROUVER LES BONNES COULEURS!!!!*/
  this.options = {
    restitution:.8,
    friction :.25
  }
  if (options) this.options.isStatic = options.isStatic;

  this.body = Bodies.circle(x,y,this.r,this.options);
  World.add(world,this.body);
}
Particle.prototype.draw = function() {
  var pos = this.body.position;
  noStroke()
  fill(this.c);
  push();
  translate(pos.x,pos.y);
  ellipse(0,0,this.r *3);
  /*ICI LA TAILLE*/
  pop();
}


// BOUNDARY
function Boundary(x,y,w,h,options,c) {
  this.x = x;
  this.y = y;
  this.w = w;
  this.h = h;

  this.c = c || 250;
  this.options = {
    restitution:.9,
    friction :0.1,
    isStatic:true,
  }
  this.body = Bodies.rectangle(this.x,this.y,this.w,this.h,this.options);
  World.add(world,this.body);
}
Boundary.prototype.draw = function() {
  var pos = this.body.position;
  noStroke();
  fill(this.c);
  push();
  translate(pos.x,pos.y);
  rect(0,0,this.w,this.h);
  pop();
}
